#!/usr/bin/python3

from tkinter import *
import time

debug=True

#Define the TKinter window
root = Tk() #Makes the window
root.wm_title("Internet Radio") # Window title
root.config(background = "#FFFFF0")

#TKinter variables, these can be bound to a control
vtime=StringVar(value="Time")
spinnum=StringVar(value="")
stationtuple=("Station 1", "Station 2", "Station 3")


#Event handlers for interface elements
def playbtnPress():
    if ( debug ): print ("Play Button Pressed")

def stopbtnPress():
    if ( debug ): print ("Stop Button Pressed")
    
def spinbtnPress():
    if ( debug ): print("Spin button pressed ")

    
def update_clock():
    vtime.set( time.strftime(" %a %B %d  %l:%M:%S %p "))
    root.after(500, update_clock)

#primaryFrame in root window
primaryFrame = Frame(root)
primaryFrame.grid(row=0, column=0, sticky=W+N, padx=10, pady=10 )
primaryFrame.grid_columnconfigure(0)

#Labels in primaryFrame
Label(primaryFrame, text="Station").grid(row=0, column=0, padx=10, pady=10)
statusLabel= Label(primaryFrame, text="..............").grid(row=12, column=0, padx=10, pady=10)

#Contents of primaryFrame

playBtn = Button(primaryFrame, text="Play", command=playbtnPress, width=10)
playBtn.grid(row=11, column=0, sticky=W, padx=10, pady=2)

stopBtn = Button(primaryFrame, text="Stop", command=stopbtnPress, width=10)
stopBtn.grid(row=11, column=0, sticky=E, padx=10, pady=2)


timeLabel= Label(primaryFrame, textvariable=vtime, font=("Helvetica", 22), fg="white", bg="black" ).grid(row=13, column=0, padx=10, pady=10)

#Create a sub frame within primaryFrame to hold the spinbox
subFrame = Frame(primaryFrame )
subFrame.grid(row=1, column=0, rowspan=10, padx=10, pady=2)

stationSpin=Spinbox(subFrame, width=25, state="readonly", textvar=spinnum, command=spinbtnPress, values=stationtuple )
stationSpin.config( font=("Helvetica", 22), wrap=True, repeatdelay=1000, repeatinterval=250)
stationSpin.pack()
#
#End of primaryFrame contents


#Now start the GUI elements

update_clock()          #Kick off the clock

root.mainloop()         #start window event loop


