#!/usr/bin/python3

from tkinter import *
from time import sleep
import RPi.GPIO as GPIO

GPIO.setmode(GPIO.BCM)
GPIO.setup(26, GPIO.OUT, pull_up_down=GPIO.PUD_UP, initial=1)

#Python variables
debug=True
tkrun=0
tkenable=0
out=0

#Define the TKinter window
root = Tk() #Makes the window
root.wm_title("GPIO Test") # Window title
root.config(background = "#FFFFF0")

#TKinter variables, these can be bound to a control

#Event handlers for interface elements
def onbtnPress():
    if ( debug ): print ("On Button Pressed")
    GPIO.output(26, 0)

def offbtnPress():
    if ( debug ): print ("Off Button Pressed")
    GPIO.output(26, 1)

def monobtnPress():
    if ( debug ): print("Mono Flash button pressed ")
    GPIO.output(26, 0)
    root.after(100, tkmono)      

def tkmono():
    GPIO.output(26, 1)  
    
def loopbtnPress():
    if ( debug == 1 ): print("Loop Flash button pressed ")
    count=0
    out=0
    while (count < 100):
        GPIO.output(26, out)
        sleep(0.05)
        out=(out+1)%2
        count +=1
    GPIO.output(26, 1)
    
def pwmbtnPress():
    if ( debug ): print("PWM button pressed ")
    mypwm=GPIO.PWM(26,10)
    mypwm.start(50)
    sleep(5.0)
    mypwm.stop()
    sleep(0.02)
    GPIO.output(26, 1)

def tkpwm():
        global out
        global tkrun
        global tkenable
        if (tkenable == 1):
            if (tkrun == 1  ):
                GPIO.output(26, out)
                out=((out + 1) %2)
            else:
                GPIO.output(26, 1)
        root.after(50, tkpwm)      
        
def tkbtnPress():
    global tkrun
    global tkenable
    if ( debug ): print("tkPWM button pressed ")
    if (tkBtn["text"] == "tkPWM Enable" ):
        tkBtn["text"]="tkPWM Disable"
        tkenable=1
    else:
        tkBtn["text"]="tkPWM Enable"
        tkenable=0


def tglbtnPress():
    global tkrun
    if ( debug ): print("Toggle tkrun button pressed ")
    tkrun=((tkrun+1) % 2)
    

def exitbtnPress():
    if ( debug ): print ("Exit Button Pressed")
    GPIO.cleanup()
    root.destroy()
    exit()

#primaryFrame in root window
primaryFrame = Frame(root)
primaryFrame.grid(row=0, column=0, sticky=W+N, padx=10, pady=10 )
primaryFrame.grid_columnconfigure(0)

#Labels in primaryFrame
#Label(primaryFrame, text="LED Test").grid(row=0, column=0, padx=10, pady=10)

#Contents of primaryFrame

onBtn = Button(primaryFrame, text="On", command=onbtnPress, width=10)
onBtn.grid(row=0, column=0, padx=10, pady=2)

offBtn = Button(primaryFrame, text="Off", command=offbtnPress, width=10)
offBtn.grid(row=1, column=0, padx=10, pady=2)

monoBtn = Button(primaryFrame, text="Monostable", command=monobtnPress, width=10)
monoBtn.grid(row=0, column=1, padx=10, pady=2)

loopBtn = Button(primaryFrame, text="Loop Flash", command=loopbtnPress, width=10)
loopBtn.grid(row=0, column=2, padx=10, pady=2)

pwmBtn = Button(primaryFrame, text="PWM Flash", command=pwmbtnPress, width=10)
pwmBtn.grid(row=1, column=2, padx=10, pady=2)

tkBtn = Button(primaryFrame, text="tkPWM Enable", command=tkbtnPress, width=10)
tkBtn.grid(row=0, column=3, padx=10, pady=2)

tglBtn = Button(primaryFrame, text="Toggle tkrun", command=tglbtnPress, width=10)
tglBtn.grid(row=1, column=3, padx=10, pady=2)

exitBtn = Button(primaryFrame, text="Exit", command=exitbtnPress, width=10)
exitBtn.grid(row=2, column=3, padx=10, pady=2)

#End of primaryFrame contents


#Now start the GUI elements

tkpwm()                 #start the tk timer
root.mainloop()         #start window event loop


