#!/usr/bin/python3

from tkinter import *
import RPi.GPIO as GPIO

indicator=False
debug=True

def setupswscan():
    GPIO.setmode(GPIO.BCM)
    GPIO.setup(26, GPIO.OUT, pull_up_down=GPIO.PUD_UP, initial=1) #LED, OFF
    for i in (21, 20, 16, 12):
        GPIO.setup(i, GPIO.IN, pull_up_down=GPIO.PUD_UP)           #SW setup
        GPIO.add_event_detect(i, GPIO.FALLING, bouncetime=150)
    swscan()

def swscan():
    global indicator
    for i in (21, 20, 16, 12):        
        #Test to see if there an event for each button
        if GPIO.event_detected(i):
            if i == 21:
                indicator=True
                if ( debug ): print("Detected BCM ", i)
                #playbtnPress()
            elif i == 20:
                indicator=True
                if ( debug ): print("Detected BCM ", i)
                #stopbtnPress()
            elif i == 16:
                indicator=True
                if ( debug ): print("Detected BCM ", i)
                #stationSpin.invoke("buttonup")
            elif i == 12:
                indicator=True
                if ( debug ): print("Detected BCM ", i)
                #stationSpin.invoke("buttondown")
            if indicator : monoLED(200)
    root.after(20, swscan )         #50Hz scan      
    

def monoLED(timer):
    global indicator
    if ( debug ): print("LED turned on")
    if indicator and GPIO.input(26) :
        indicator=False
        GPIO.output(26, 0)
        root.after(timer, monotimeout)      

def monotimeout():
    global indicator
    GPIO.output(26, 1)


root = Tk()             #Makes the root window

setupswscan()           #start scanning

root.mainloop()         #start window event loop

