#!/usr/bin/python


import sys
import RPi.GPIO as GPIO

LEDport=26
switchports=(21,20,16,12)

def flushout(mystring):
    sys.stdout.write(mystring)
    sys.stdout.flush()

def initgpio():
    #set up LED port and four switch detectors
    GPIO.setmode(GPIO.BCM)
    GPIO.setup(26, GPIO.OUT, pull_up_down=GPIO.PUD_UP, initial=1) #LED, OFF
    for i in (switchports):
        GPIO.setup(i, GPIO.IN, pull_up_down=GPIO.PUD_UP)           #SW setup
        GPIO.add_event_detect(i, GPIO.FALLING, bouncetime=200)

# pipe commands

def LEDon():
    GPIO.output(LEDport, 0)

def LEDoff():
    GPIO.output(LEDport, 1)

def rdswevents():
    swevents=[]
    for i in (switchports):
        if GPIO.event_detected(i):
            swevents.append(1)
        else:
            swevents.append(0)
    flushout (str(swevents) + ' ' )

def closeandexit():
    GPIO.cleanup()
    sys.exit('Bye....')

    
def main():
    #Init the switches
    initgpio()

    while True:
        flushout('ok:\n')
        global cmddata
        try:
            inputstr=raw_input()
            inputstr += ',0,0'                  #need at least one item
            cmddata = eval(inputstr,{'__builtins__':None},
                           {'LEDon':LEDon,
                            'LEDoff':LEDoff,
                            'rdswevents':rdswevents,
                            'close':closeandexit})
            cmddata[0]()                        #execute the command
        except (KeyboardInterrupt, EOFError, NameError, SyntaxError, IndexError, TypeError) as err:
            if 'KeyboardInterrupt' in str(type(err)): break
            if 'EOFError' in str(type(err)): break
            flushout(str(err) + ', ')
    

if __name__ ==  '__main__':

    main()
    
