#!/usr/bin/python

import sys
from time import time
from subprocess import call, Popen, PIPE, STDOUT

piperef=[0,1]
digio=0
printon=False

def initpipe(pipenum, progstr):
    global piperef
    try:
        with open( progstr + '_stderr_' + str(pipenum) + '.txt', 'wb') as err:
            piperef[pipenum]=Popen(['sudo', 'python', progstr],
                                   stdout=PIPE, stdin=PIPE, stderr=err)
            x = piperef[pipenum].stdout.readline()
            if 'ok:' in x:
                print progstr + ' ready'
                return False
            else:
                print 'Wrong response from child ' + progstr
                return True
    except IOError:
        print 'IOError on init'
        return True

    
def pingpipe(pipenum, sendstr):
    global piperef
    try:
        piperef[pipenum].stdin.write(sendstr)
        piperef[pipenum].stdin.flush()
        return piperef[pipenum].stdout.readline()
    except IOError:
        print 'IOError on pipe send ', pipenum
        return True
    
def main():
    if  initpipe(digio, 'rbuttons1.py'):
        #an Error occured
        print 'Error creating pipe ', digio
        exit
        #Loop test for transaction count
    print 'Testing transaction rate...'
    start=time()
    if printon:
        loopcount=200
    else:
        loopcount=2000
    for i in range(1,loopcount):
        x = pingpipe(digio, 'LEDon\n' )
        if x == True:
            print 'Error on pipe send ', digio
        else:
            if printon : print 'Pipe=', digio, x,
        
        x = pingpipe(digio, 'LEDoff\n')
        if x == True:
            print 'Error on pipe send', digio
        else:
            if printon : print 'Pipe=', digio, x,
    stop=time()
    print int(2 * loopcount/(stop-start)), 'transactions per second'

    #Wait for switch action
    print 'Waiting for a switch....'
    while True:
        x = pingpipe(digio, 'rdswevents\n' )
        if x == True:
            print 'Error on pipe send ', digio
        else:
            if 'ok:' in x and x[11] == ']':
                y=eval(x[0:12])
                if y[0] :
                    z=Popen(['sudo', 'shutdown', '-h', 'now'])
                    print 'Shutdown in process'
                    break
                if y[1] : break
            else:
                print 'Return string error '

    sys.exit('Closing application')



if __name__ ==  '__main__':

    main()
    
