#!/usr/bin/python

import sys
from time import time
from subprocess import call, Popen, PIPE, STDOUT

piperef=[0,1]
camref=0
printon=False

def initpipe(pipenum, progstr):
    global piperef
    try:
        with open( progstr + '_stderr_' + str(pipenum) + '.txt', 'wb') as err:
            piperef[pipenum]=Popen(['python', progstr],
                                   stdout=PIPE, stdin=PIPE, stderr=err)
            x = piperef[pipenum].stdout.readline()
            if 'ok:' in x:
                print progstr + ' ready'
                return False
            else:
                print 'Wrong response from child ' + progstr
                return True
    except IOError:
        print 'IOError on init'
        return True

    
def pingpipe(pipenum, sendstr):
    global piperef
    try:
        piperef[pipenum].stdin.write(sendstr)
        piperef[pipenum].stdin.flush()
        return piperef[pipenum].stdout.readline()
    except IOError:
        print 'IOError on pipe send ', pipenum
        return True
    
def main():
    if  initpipe(camref, 'rcam.py'):
        #an Error occured
        print 'Error creating pipe ', camref
        exit
    #Loop test for transaction count
    print 'Testing frame rate...'
    start=time()
    loopcount=100
    for i in range(1,loopcount):
        x = pingpipe(camref, 'line0\n' )
        if x == True:
            print 'Error on pipe send ', camref
        else:
            if printon : print 'Pipe=', camref, x,
    stop=time()
    print str(loopcount/(stop-start)), 'frames per second'

    sys.exit('Closing application')


if __name__ ==  '__main__':

    main()
    
