#!/usr/bin/python

import sys
from time import time
from subprocess import call, Popen, PIPE, STDOUT

piperef=[0,1]
campipe=0
i2cpipe=1
printon=False


def initpipe(pipenum, progstr):
    global piperef
    try:
        with open('stderr_' + str(pipenum) + '.txt', 'wb') as err:
            piperef[pipenum]=Popen(['python', progstr],
                                   stdout=PIPE, stdin=PIPE, stderr=err)
            x = piperef[pipenum].stdout.readline()
            if 'ok:' in x:
                print progstr + ' ready'
                return False
            else:
                print 'Wrong response from child ' + progstr
                return True
    except IOError:
        print 'IOError on init'
        return True

    
def pingpipe(pipenum, sendstr):
    global piperef
    try:
        piperef[pipenum].stdin.write(sendstr)
        piperef[pipenum].stdin.flush()
        return piperef[pipenum].stdout.readline()
    except IOError:
        print 'IOError on pipe send ', pipenum
        return True
        

    
def main():
    if  initpipe(campipe, 'listener1.py'):
        #an Error occured
        print 'Error creating pipe ', campipe
        exit
    if  initpipe(i2cpipe, 'listener1.py'):
        #an Error occured
        print 'Error creating pipe ', i2cpipe
        exit
    start=time()
    if printon:
        loopcount=200
    else:
        loopcount=2000
    for i in range(1,loopcount):
        x = pingpipe(campipe, 'userfunc2\n' )
        if x == True:
            print 'Error on pipe send ', campipe
        else:
            if printon : print 'Pipe=', campipe, x,
        
        x = pingpipe(i2cpipe, 'userfunc1,2,3\n')
        if x == True:
            print 'Error on pipe send', i2cpipe
        else:
            if printon : print 'Pipe=', i2cpipe, x,
    stop=time()
    print int(2 * loopcount/(stop-start)), 'transactions per second'

    
    piperef[campipe].kill()
    piperef[i2cpipe].kill()


if __name__ ==  '__main__':

    main()
    
