#!/usr/bin/python

import sys
from time import time
from subprocess import call, Popen, PIPE, STDOUT

piperef=[0,1]
wheelref=0
printon=False

def initpipe(pipenum, progstr):
    global piperef
    try:
        with open( progstr + '_stderr_' + str(pipenum) + '.txt', 'wb') as err:
            piperef[pipenum]=Popen(['sudo', 'python', progstr],
                                   stdout=PIPE, stdin=PIPE, stderr=err)
            x = piperef[pipenum].stdout.readline()
            if 'ok:' in x:
                print progstr + ' ready'
                return False
            else:
                print 'Wrong response from child ' + progstr
                return True
    except IOError:
        print 'IOError on init....'
        return True

    
def pingpipe(pipenum, sendstr):
    global piperef
    try:
        piperef[pipenum].stdin.write(sendstr)
        piperef[pipenum].stdin.flush()
        return piperef[pipenum].stdout.readline()
    except IOError:
        print 'IOError on pipe send ', pipenum
        return True
    
def main():
    if  initpipe(wheelref, 'rwheel.py'):
        #an Error occured
        print 'Error creating pipe ', wheelref
        exit
    #Loop test for transaction count
    print 'Testing transaction rate...'
    start=time()
    loopcount=1000
    for i in range(1,loopcount):
        x = pingpipe(wheelref, 'servowr,0,450\n' )
        if x == True:
            print 'Error on pipe send ', wheelref
        else:
            if printon : print 'Pipe=', wheelref, x,
    x = pingpipe(wheelref, 'servonuetral\n' )
    stop=time()
    print int(loopcount/(stop-start)), 'transactions per second'

    sys.exit('Closing application')


if __name__ ==  '__main__':

    main()
    
